diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererGhast.java b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererGhast.java
index 93335d9d6..441354d2f 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererGhast.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererGhast.java
@@ -1,36 +1,57 @@
 package net.minecraft.client.render.entity;
 
-import net.minecraft.client.render.model.ModelGhast;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.entity.monster.MobGhast;
+import net.minecraft.core.util.helper.MathHelper;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 import org.lwjgl.opengl.GL11;
+import org.useless.dragonfly.models.entity.BoneTransform;
+import org.useless.dragonfly.models.entity.StaticEntityModel;
 
-public class MobRendererGhast extends MobRenderer<MobGhast>
-{
+public class MobRendererGhast extends MobRenderer<MobGhast> {
 
-    public MobRendererGhast()
-    {
-        super(new ModelGhast(), 0.5F);
+    public MobRendererGhast(final float shadowSize) {
+        super(shadowSize);
     }
 
     @Override
-    public void renderPreview(Tessellator tessellator, MobGhast mobGhast, double x, double y, double z, float yaw, float partialTick) {
+    protected @Nullable StaticEntityModel getAndSetupModelForLayer(@NotNull final MobGhast entity, final float brightness, final float partialTick, final int layer) {
+        final StaticEntityModel model = getModel("main");
+        model.resetBones();
+
+        final BoneTransform body = model.getTransform("body");
+
+        float charge = MathHelper.lerp(entity.attackChargeO, entity.attackCharge, partialTick) / 20F;
+        if(charge < 0.0F) { charge = 0.0F; }
+        charge = 1.0F / (charge * charge * charge * charge * charge * 2.0F + 1.0F);
+        final float sHeight = (8F + charge) / 2.0F;
+        final float sWidth = (8F + 1.0F / charge) / 2.0F;
+
+        final float limbPitch = getLimbPitch(entity, partialTick);
+
+        body.scaleX = sWidth;
+        body.scaleY = sHeight;
+        body.scaleZ = sWidth;
+
+        model.getTransform("tentacles_0").rotX = 0.2F * MathHelper.sin(limbPitch * 0.3F + (float) 0) + 0.4F;
+        model.getTransform("tentacles_1").rotX = 0.2F * MathHelper.sin(limbPitch * 0.3F + (float) 1) + 0.4F;
+        model.getTransform("tentacles_2").rotX = 0.2F * MathHelper.sin(limbPitch * 0.3F + (float) 2) + 0.4F;
+        model.getTransform("tentacles_3").rotX = 0.2F * MathHelper.sin(limbPitch * 0.3F + (float) 3) + 0.4F;
+        model.getTransform("tentacles_4").rotX = 0.2F * MathHelper.sin(limbPitch * 0.3F + (float) 4) + 0.4F;
+        model.getTransform("tentacles_5").rotX = 0.2F * MathHelper.sin(limbPitch * 0.3F + (float) 5) + 0.4F;
+        model.getTransform("tentacles_6").rotX = 0.2F * MathHelper.sin(limbPitch * 0.3F + (float) 6) + 0.4F;
+        model.getTransform("tentacles_7").rotX = 0.2F * MathHelper.sin(limbPitch * 0.3F + (float) 7) + 0.4F;
+        model.getTransform("tentacles_8").rotX = 0.2F * MathHelper.sin(limbPitch * 0.3F + (float) 8) + 0.4F;
+
+        return model;
+    }
+
+    @Override
+    public void renderPreview(@NotNull final Tessellator tessellator, @NotNull final MobGhast mobGhast, final double x, final double y, final double z, final float yaw, final float partialTick) {
         GL11.glPushMatrix();
         GL11.glScalef(0.25f, 0.25f, 0.25f);
         super.renderPreview(tessellator, mobGhast, x, y, z, yaw, partialTick);
         GL11.glPopMatrix();
     }
-
-    @Override
-    protected void setupScale(MobGhast mobGhast, float partialTick) {
-        float charge = ((float) mobGhast.attackChargeO + (float)(mobGhast.attackCharge - mobGhast.attackChargeO) * partialTick) / 20F;
-        if(charge < 0.0F)
-        {
-            charge = 0.0F;
-        }
-        charge = 1.0F / (charge * charge * charge * charge * charge * 2.0F + 1.0F);
-        float f2 = (8F + charge) / 2.0F;
-        float f3 = (8F + 1.0F / charge) / 2.0F;
-        GL11.glScalef(f3, f2, f3);
-    }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererGiant.java b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererGiant.java
index f618a656c..3912d9bbc 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererGiant.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererGiant.java
@@ -1,23 +1,23 @@
 package net.minecraft.client.render.entity;
 
-import net.minecraft.client.render.model.ModelBase;
-import net.minecraft.core.entity.monster.MobGiant;
+import net.minecraft.core.entity.monster.MobZombie;
+import org.jetbrains.annotations.NotNull;
 import org.lwjgl.opengl.GL11;
 
-public class MobRendererGiant extends MobRenderer<MobGiant>
+public class MobRendererGiant extends MobRendererZombie
 {
+    private final float scale;
 
-    public MobRendererGiant(ModelBase modelbase, float f, float f1)
+    public MobRendererGiant(final float shadowSizeUnscaled, final float scale)
     {
-        super(modelbase, f * f1);
-        scale = f1;
+        super(shadowSizeUnscaled * scale);
+        this.scale = scale;
     }
 
     @Override
-    protected void setupScale(MobGiant entity, float partialTick)
-    {
-        GL11.glScalef(scale, scale, scale);
+    protected void preRenderTransform(@NotNull final MobZombie entity, final double x, final double y, final double z, final float yaw, final float partialTick) {
+        super.preRenderTransform(entity, x, y, z, yaw, partialTick);
+        GL11.glScalef(this.scale, this.scale, this.scale);
     }
 
-    private float scale;
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererHuman.java b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererHuman.java
index 6a34d18e2..f87c43905 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererHuman.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererHuman.java
@@ -1,59 +1,46 @@
 package net.minecraft.client.render.entity;
 
 import net.minecraft.client.render.PlayerSkinParser;
-import net.minecraft.client.render.model.ModelBiped;
-import net.minecraft.client.render.model.ModelPlayer;
-import net.minecraft.client.render.model.ModelPlayerSlim;
-import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.entity.monster.MobHuman;
+import net.minecraft.core.util.helper.MathHelper;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 import org.lwjgl.opengl.GL11;
+import org.useless.dragonfly.models.entity.StaticEntityModel;
 
-public class MobRendererHuman extends MobRenderer<MobHuman>
+public class MobRendererHuman extends MobRendererBiped<MobHuman>
 {
-    public MobRendererHuman()
-    {
-        super(new ModelPlayer(0.0F), 0.5F);
-        modelBipedMain = (ModelBiped)mainModel;
-//        modelArmorChestplate = new ModelBiped(1.0F);
-//        modelArmor = new ModelBiped(0.5F);
-        modelThick = new ModelPlayer(0.0f);
-        modelSlim = new ModelPlayerSlim(0.0f);
+    public MobRendererHuman() {
+        super(0.5f);
     }
+
     @Override
-    public void render(Tessellator tessellator, MobHuman entity, double x, double y, double z, float yaw, float partialTick) {
-        GL11.glEnable(GL11.GL_BLEND);
-        GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
-        mainModel = entity.slimModel ? modelSlim : modelThick;
+    protected void preRenderTransform(@NotNull final MobHuman entity, final double x, final double y, final double z, final float yaw, final float partialTick) {
+        GL11.glTranslated(x, y, z);
+        GL11.glRotatef(-getBodyYaw(entity, partialTick) * MathHelper.RAD_TO_DEG, 0, 1, 0);
+        GL11.glScalef(1/ENTITY_RENDER_SCALE, 1/ENTITY_RENDER_SCALE, -1/ENTITY_RENDER_SCALE);
 
-//        ItemStack itemstack = entity.getHeldItem();
-//        modelArmorChestplate.field_1278_i = modelArmor.field_1278_i = modelBipedMain.field_1278_i = itemstack != null;
-//        modelArmorChestplate.isSneak = modelArmor.isSneak = modelBipedMain.isSneak = entity.isSneaking();
-//        modelArmorChestplate.isRiding = modelArmor.isRiding = modelBipedMain.isRiding = entity.isPassenger();
-        double yRender = y - (double)entity.heightOffset;
-        if(entity.isSneaking())
-        {
-            yRender -= 0.125D;
+        final float scale = 0.9375F;
+        GL11.glScalef(scale, scale, scale);
+
+        if(entity.deathTime > 0) {
+            float rotationProgress = (((entity.deathTime + partialTick) - 1.0F) / 20F) * 1.6F;
+            rotationProgress = MathHelper.sqrt_float(rotationProgress);
+            if(rotationProgress > 1.0F) {
+                rotationProgress = 1.0F;
+            }
+            GL11.glRotatef(rotationProgress * getMaxDeathRotation(entity), 0.0F, 0.0F, 1.0F);
         }
-        super.render(tessellator, entity, x, yRender, z, yaw, partialTick);
-//        modelArmorChestplate.isSneak = modelArmor.isSneak = modelBipedMain.isSneak = false;
-//        modelArmorChestplate.field_1278_i = modelArmor.field_1278_i = modelBipedMain.field_1278_i = false;
-        GL11.glDisable(GL11.GL_BLEND);
     }
+
     @Override
-    protected void setupScale(MobHuman entity, float partialTick)
+    public void loadEntityTexture(final @NotNull MobHuman entity)
     {
-        float scale = 0.9375F;
-        GL11.glScalef(scale, scale, scale);
+        bindDownloadableTexture(entity.skinUrl, entity.getEntityTexture(), PlayerSkinParser.instance);
     }
 
     @Override
-    public void loadEntityTexture(MobHuman entity)
-    {
-        bindDownloadableTexture(entity.skinUrl, entity.getEntityTexture(), PlayerSkinParser.instance);
+    protected @Nullable StaticEntityModel getActiveModel(@NotNull final MobHuman entity) {
+        return entity.slimModel ? getModel("main.slim") : getModel("main");
     }
-    private final ModelBiped modelBipedMain;
-    private final ModelPlayer modelThick;
-    private final ModelPlayer modelSlim;
-//    private final ModelBiped modelArmorChestplate;
-//    private final ModelBiped modelArmor;
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererPig.java b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererPig.java
index d0588eece..5c85103b8 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererPig.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererPig.java
@@ -1,26 +1,53 @@
 package net.minecraft.client.render.entity;
 
-import net.minecraft.client.render.model.ModelBase;
 import net.minecraft.core.entity.animal.MobPig;
+import net.minecraft.core.util.helper.MathHelper;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+import org.useless.dragonfly.models.entity.BoneTransform;
+import org.useless.dragonfly.models.entity.StaticEntityModel;
 
-public class MobRendererPig extends MobRenderer<MobPig>
-{
+public class MobRendererPig extends MobRendererQuadruped<MobPig> {
 
-    public MobRendererPig(ModelBase modelbase, ModelBase modelbase1, float f)
-    {
-        super(modelbase, f);
-        setArmorModel(modelbase1);
+    public MobRendererPig(final float shadowSize) {
+        super(shadowSize);
     }
 
-    protected boolean renderSaddledPig(MobPig entity, int i, float f)
-    {
-        bindTexture("/assets/minecraft/textures/entity/saddle.png");
-        return i == 0 && entity != null && entity.getSaddled();
+    @Override
+    protected @Nullable StaticEntityModel getAndSetupModelForLayer(@NotNull final MobPig entity, final float brightness, final float partialTick, final int layer) {
+        final StaticEntityModel model;
+        if (layer == 1) {
+            bindTexture("/assets/minecraft/textures/entity/saddle.png");
+            model = getModel("saddle");
+        } else {
+            model = getModel("main");
+        }
+        model.resetBones();
+
+        final BoneTransform head = model.getTransform("head");
+        final BoneTransform leg0 = model.getTransform("leg0");
+        final BoneTransform leg1 = model.getTransform("leg1");
+        final BoneTransform leg2 = model.getTransform("leg2");
+        final BoneTransform leg3 = model.getTransform("leg3");
+
+        final float bodyYaw = getBodyYaw(entity, partialTick);
+        final float headYaw = getHeadYaw(entity, partialTick) - bodyYaw;
+        final float headPitch = getHeadPitch(entity, partialTick);
+        final float limbSwing = getLimbSwing(entity, partialTick);
+        final float limbYaw = getLimbYaw(entity, partialTick);
+
+        head.rotX = headPitch;
+        head.rotY = headYaw;
+        leg0.rotX = MathHelper.cos(limbSwing * 0.6662F) * 1.4F * limbYaw;
+        leg1.rotX = MathHelper.cos(limbSwing * 0.6662F + MathHelper.PI) * 1.4F * limbYaw;
+        leg2.rotX = MathHelper.cos(limbSwing * 0.6662F + MathHelper.PI) * 1.4F * limbYaw;
+        leg3.rotX = MathHelper.cos(limbSwing * 0.6662F) * 1.4F * limbYaw;
+
+        return model;
     }
 
     @Override
-    protected boolean prepareArmor(MobPig entity, int renderPass, float partialTick)
-    {
-        return renderSaddledPig(entity, renderPass, partialTick);
+    protected int maxRenderLayer(@NotNull final MobPig entity) {
+        return entity.getSaddled() ? 1 : 0;
     }
 }
